config/routes.rb
Rails.application.routes.draw do
  mount Ckeditor::Engine => '/ckeditor'
  devise_for :users, controllers: {registrations: "registrations"}
  post 'likes/create'
  post 'likes/destroy'
  post 'dislikes/create'
  post 'dislikes/destroy'
  post 'comments/reply'
  post 'comments/approve'
  get 'post/my', to: 'posts#my', as: :my_posts
  get 'posts/index', to: 'posts#index', as: :post_index

  resources :posts do
    resources :comments
    resources :ratings
  end

  resources :admin do
    resources :tags

    root to: "tags#index"
  end

  resources :tags
  resources :users

  root 'posts#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  acts_as_tree order: 'created_at DESC'
  belongs_to :user
  belongs_to :post #, dependent: :destroy
  has_many :like, dependent: :destroy
  has_many :dislike, dependent: :destroy

  validates :title, presence: {message: "Missing title"}
  validates :content, presence: {message: "Missing content"}

  before_save :generate_timestamp

  def generate_timestamp
    self.added = DateTime.now
  end

  def likes_count
    self.like.count()
  end

  def can_like id
    self.like.where(user_id: id).empty?
  end

  def dislikes_count
    self.dislike.count()
  end

  def can_dislike id
    self.dislike.where(user_id: id).empty?
  end

end

app/models/dislike.rb
class Dislike < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/post.rb
class Post < ApplicationRecord
  has_attached_file :image, styles: { large: "900x900>", medium: "500x500>", thumb: "100x100>" }
  validates_attachment_content_type :image, content_type: /\Aimage\/.*\z/


  has_many :comments, dependent: :destroy

  has_many :ratings, dependent: :destroy
  has_and_belongs_to_many :tags

  belongs_to :user

  has_one :post_option

  validates :title, presence: {message: "Missing title"}
  validates :perex, presence: {message: "Missing perex"}
  validates :text, presence: {message: "Missing text"}

  before_save :generate_timestamp
  before_create :build_associations

  def generate_timestamp
    self.added = DateTime.now
  end

  def assign_params_from_controller(params)
    @option_params = params
  end

  def build_associations
    #PostOption.new(@option_params).save
    self.post_option = PostOption.new(@option_params)
  end

  def primary_comments
    self.comments.where(parent_id: nil, approved: true).order(created_at: :desc)
  end

  def not_allowed_comments_for_current_user id
    self.comments.where(user_id: id, approved: false).order(created_at: :desc)
  end

  def not_allowed_comments
    self.comments.where(approved: false).order(created_at: :desc)
  end

end

app/models/post_option.rb
class PostOption < ApplicationRecord
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :user
  belongs_to :post
  validates :value, numericality: { only_integer: true }, inclusion: { :in => [ 1, 2, 3, 4, 5 ] }
end

app/models/tag.rb
class Tag < ApplicationRecord
  has_and_belongs_to_many :posts
  validates :name, presence: {message: "Missing name of tag"}

end

app/models/under_comment.rb
class UnderComment < ApplicationRecord
  belongs_to :comment, dependent: :destroy
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :confirmable
  has_many :posts
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/dislikes_helper.rb
module DislikesHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/helpers/tag_posts_helper.rb
module TagPostsHelper
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/admin/index.html.erb
<table>
  <tr>
    <th>Name</th>
    <th colspan="1"></th>
  </tr>

  <% @tags.each do |tag| %>
    <tr>
      <td><%= tag.name %></td>
      <td><%= link_to 'Read', tag_path(tag) %></td>
      <td><%= link_to 'Edit', edit_tag_path(tag) %></td>
      <td><%= link_to 'Delete', tag_path(tag),
                      method: :delete,
                      data: { confirm: 'Are you sure?' } %></td>
    </tr>
  <% end %>
</table>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title><%= content_for?(:title) ? yield(:title) : "Blog" %></title>
  <%= csrf_meta_tags %>

  <%= stylesheet_link_tag "application", :media => "all" %>



  <%= javascript_include_tag "application" %>

  <!-- Le HTML5 shim, for IE6-8 support of HTML elements -->
  <!--[if lt IE 9]>
  <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.2/html5shiv.min.js" type="text/javascript"></script>
  <![endif]-->

  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <!-- <link href="/assets/stylesheets/my.css" rel="stylesheet" /> -->

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

</head>
<body>

<!-- MENU TOP  -->
<div class="navbar navbar-inverse navbar-static-top">
  <div class="container">
    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-responsive-collapse">
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
    </button>
    <a><%= link_to 'FoodBlog', posts_path, { :class=>"navbar-brand" } %></a>

    <div class="navbar-collapse collapse navbar-responsive-collapse">
      <ul class="nav navbar-nav">
        <!-- if user signed in = logout otherwise login -->
        <% if user_signed_in? %>
          <li><%# link_to 'Profile', edit_user_registration_path %></li>
          <li><%= link_to "Log out", destroy_user_session_path, :method => 'delete' %></li>
        <% else %>
          <li><%= link_to t('.sign_in', default: 'Sign in'), new_session_path(resource_name) %></li>
        <% end %>
      </ul>
    </div>
  </div>
</div>



<div class="container">
  <div class="row">
    <!--  login form -->
    <div class="col-lg-9">
      <%= bootstrap_flash %>
      <%= yield %>
    </div>
    <!--  MENU RIGHT just for signed users -->
    <% if user_signed_in? %>
    <div class="col-lg-3">
      <div class="well sidebar-nav">
        <div class="side-menu-title">
          <% unless current_user.nil? %>
            <h3><%= current_user.name %></h3>
          <% else %>
            <h3>My menu</h3>
          <% end %>
        </div>

        <ul class="nav nav-list" data-no-turbolink>
          <li data-no-turbolink><%= link_to 'New post', new_post_path, data: {"no-turbolink" => true} %></li>
          <li><%= link_to 'My posts', my_posts_path %></li>
          <li><%= link_to 'Profile', edit_user_registration_path %></li>
          <li><%= link_to 'Tags', tags_path %></li>
        </ul>

      </div><!--/.well -->
    </div><!--/span-->
    <% end %>
  </div><!--/row-->


  

</div> <!-- /container -->
<footer class="footer-bg-dark">
    <p class="center">&copy; 2018 Eva Ambrusova & Viola Kleinova</p>
</footer>

</body>
</html>